# generated by datamodel-codegen

from __future__ import annotations

from typing import Dict, List, Optional

from pydantic import AwareDatetime, Field
from typing_extensions import Annotated

from pipekit_sdk.models._config import BaseModel


class Cluster(BaseModel):
    api_key: Annotated[Optional[str], Field(alias="apiKey")] = None
    created_at: Annotated[AwareDatetime, Field(alias="createdAt")]
    description: str
    identity_uuid: Annotated[str, Field(alias="identityUUID")]
    is_active: Annotated[bool, Field(alias="isActive")]
    is_registered: Annotated[bool, Field(alias="isRegistered")]
    name: str
    org_uuid: Annotated[str, Field(alias="orgUUID")]
    pipekit_agent_version: Annotated[str, Field(alias="pipekitAgentVersion")]
    port: Optional[int] = None
    type: List[str]
    updated_at: Annotated[AwareDatetime, Field(alias="updatedAt")]
    uuid: str
    workflow_group_priorities: Annotated[Optional[Dict[str, int]], Field(alias="workflowGroupPriorities")] = None


class GitInfo(BaseModel):
    git_branch_name: Annotated[Optional[str], Field(alias="gitBranchName")] = None
    git_org: Annotated[str, Field(alias="gitOrg")]
    git_repo_id: Annotated[str, Field(alias="gitRepoID")]
    git_repo_name: Annotated[str, Field(alias="gitRepoName")]
    git_request_number: Annotated[Optional[str], Field(alias="gitRequestNumber")] = None
    git_sha: Annotated[Optional[str], Field(alias="gitSHA")] = None
    git_tag: Annotated[Optional[str], Field(alias="gitTag")] = None
    git_target_branch: Annotated[Optional[str], Field(alias="gitTargetBranch")] = None
    run_uuid: Annotated[Optional[str], Field(alias="runUUID")] = None
    uuid: Optional[str] = None


class Logs(BaseModel):
    container_name: Annotated[str, Field(alias="containerName")]
    created_at: Annotated[AwareDatetime, Field(alias="createdAt")]
    identity_uuid: Annotated[str, Field(alias="identityUUID")]
    log_type: Annotated[str, Field(alias="logType")]
    node_id: Annotated[Optional[str], Field(alias="nodeId")] = None
    output: str
    pipe_uuid: Annotated[str, Field(alias="pipeUUID")]
    pod_name: Annotated[str, Field(alias="podName")]
    run_uuid: Annotated[str, Field(alias="runUUID")]
    stream_cursor: Annotated[str, Field(alias="streamCursor")]
    updated_at: Annotated[AwareDatetime, Field(alias="updatedAt")]


class Pipe(BaseModel):
    uuid: Annotated[Optional[str], Field(alias="UUID")] = None
    config_file_location: Annotated[Optional[str], Field(alias="configFileLocation")] = None
    created_at: Annotated[Optional[str], Field(alias="createdAt")] = None
    description: str
    external: bool
    has_deploy_key: Annotated[Optional[bool], Field(alias="hasDeployKey")] = None
    identity_uuid: Annotated[Optional[str], Field(alias="identityUUID")] = None
    is_active: Annotated[bool, Field(alias="isActive")]
    kube_namespace: Annotated[Optional[str], Field(alias="kubeNamespace")] = None
    name: str
    org_uuid: Annotated[str, Field(alias="orgUUID")]
    third_party_account_uuid: Annotated[Optional[str], Field(alias="thirdPartyAccountUUID")] = None
    third_party_repo_id: Annotated[Optional[str], Field(alias="thirdPartyRepoID")] = None
    third_party_repo_name: Annotated[Optional[str], Field(alias="thirdPartyRepoName")] = None
    updated_at: Annotated[Optional[str], Field(alias="updatedAt")] = None


class PipeRun(BaseModel):
    check_id: Annotated[Optional[int], Field(alias="checkId")] = None
    cluster_name: Annotated[Optional[str], Field(alias="clusterName")] = None
    cluster_uuid: Annotated[Optional[str], Field(alias="clusterUUID")] = None
    created_at: Annotated[Optional[AwareDatetime], Field(alias="createdAt")] = None
    git_info: Annotated[Optional[GitInfo], Field(alias="gitInfo")] = None
    identity_uuid: Annotated[Optional[str], Field(alias="identityUUID")] = None
    message: Optional[str] = None
    org_name: Annotated[Optional[str], Field(alias="orgName")] = None
    org_uuid: Annotated[Optional[str], Field(alias="orgUUID")] = None
    pipe_name: Annotated[Optional[str], Field(alias="pipeName")] = None
    pipe_uuid: Annotated[Optional[str], Field(alias="pipeUUID")] = None
    progress: Optional[str] = None
    run_condition_uuid: Annotated[Optional[str], Field(alias="runConditionUUID")] = None
    secret_env_uuid: Annotated[Optional[str], Field(alias="secretEnvUUID")] = None
    sha_branch_or_tag: Annotated[Optional[str], Field(alias="shaBranchOrTag")] = None
    source_name: Annotated[Optional[str], Field(alias="sourceName")] = None
    source_type: Annotated[Optional[str], Field(alias="sourceType")] = None
    status: Optional[str] = None
    updated_at: Annotated[Optional[AwareDatetime], Field(alias="updatedAt")] = None
    user_name: Annotated[Optional[str], Field(alias="userName")] = None
    uuid: Optional[str] = None
